diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/RTIA/OwnershipManagement.cc origin/RTIA/OwnershipManagement.cc
--- patched/RTIA/OwnershipManagement.cc	2012-01-16 10:12:27.000000000 +0400
+++ origin/RTIA/OwnershipManagement.cc	2010-03-23 16:13:27.000000000 +0300
@@ -350,13 +350,13 @@
                                               FederateHandle the_owner,
                                               TypeException &)
 {
-    DEFINE_REQ( M_Inform_Attribute_Ownership );
+    M_Inform_Attribute_Ownership req;
 
-    req->setObject(the_object);
-    req->setAttribute(the_attribute);
-    req->setFederate(the_owner);
+    req.setObject(the_object);
+    req.setAttribute(the_attribute);
+    req.setFederate(the_owner);
 
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -367,13 +367,13 @@
                                          FederateHandle,
                                          TypeException &)
 {
-    DEFINE_REQ( M_Attribute_Is_Not_Owned );
+    M_Attribute_Is_Not_Owned req;
 
-    req->setObject(the_object);
-    req->setAttribute(the_attribute);
+    req.setObject(the_object);
+    req.setAttribute(the_attribute);
     // req.setFederate(the_owner);
 
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -386,15 +386,15 @@
                               FederateHandle,
                               TypeException &)
 {
-    DEFINE_REQ( M_Attribute_Ownership_Unavailable );
+    M_Attribute_Ownership_Unavailable req;
 
-    req->setObject(the_object);
-    req->setAttributesSize(the_size);
+    req.setObject(the_object);
+    req.setAttributesSize(the_size);
     for (uint32_t i=0;i<the_size;++i) {
-        req->setAttributes(the_attributes[i], i);
+        req.setAttributes(the_attributes[i], i);
     }
 
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -407,15 +407,15 @@
                                           FederateHandle,
                                           TypeException &)
 {
-    DEFINE_REQ( M_Attribute_Ownership_Acquisition_Notification );
+    M_Attribute_Ownership_Acquisition_Notification req;
 
-    req->setObject(the_object);
-    req->setAttributesSize(the_size);
+    req.setObject(the_object);
+    req.setAttributesSize(the_size);
     for (uint32_t i=0;i<the_size;++i) {
-    	req->setAttributes(the_attributes[i], i);
+    	req.setAttributes(the_attributes[i], i);
     }
 
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -429,15 +429,15 @@
                                     const std::string& the_tag,
                                     TypeException &)
 {
-    DEFINE_REQ( M_Request_Attribute_Ownership_Assumption );
+    M_Request_Attribute_Ownership_Assumption req;
 
-    req->setObject(the_object);
-    req->setTag(the_tag);
-    req->setAttributesSize(the_size);
+    req.setObject(the_object);
+    req.setTag(the_tag);
+    req.setAttributesSize(the_size);
     for (uint32_t i=0;i<the_size;++i) {
-    	req->setAttributes(the_attributes[i], i);
+    	req.setAttributes(the_attributes[i], i);
     }
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -450,15 +450,15 @@
                                  const std::string& the_tag,
                                  TypeException &)
 {
-    DEFINE_REQ( M_Request_Attribute_Ownership_Release );
+    M_Request_Attribute_Ownership_Release req;
 
-    req->setObject(the_object);
-    req->setTag(the_tag);
-    req->setAttributesSize(the_size);
+    req.setObject(the_object);
+    req.setTag(the_tag);
+    req.setAttributesSize(the_size);
     for (uint32_t i=0;i<the_size;++i) {
-    	req->setAttributes(the_attributes[i], i);
+    	req.setAttributes(the_attributes[i], i);
     }
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -470,14 +470,14 @@
                                           uint32_t the_size,
                                           TypeException &)
 {
-    DEFINE_REQ( M_Attribute_Ownership_Divestiture_Notification );
+    M_Attribute_Ownership_Divestiture_Notification req;
 
-    req->setObject(the_object);
-    req->setAttributesSize(the_size);
+    req.setObject(the_object);
+    req.setAttributesSize(the_size);
     for (uint32_t i=0;i<the_size;++i) {
-    	req->setAttributes(the_attributes[i], i);
+    	req.setAttributes(the_attributes[i], i);
     }
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -489,14 +489,14 @@
                                                  uint32_t the_size,
                                                  TypeException &)
 {
-	DEFINE_REQ( M_Confirm_Attribute_Ownership_Acquisition_Cancellation );
+    M_Confirm_Attribute_Ownership_Acquisition_Cancellation req;
 
-    req->setObject(the_object);
-    req->setAttributesSize(the_size);
+    req.setObject(the_object);
+    req.setAttributesSize(the_size);
     for (uint32_t i=0;i<the_size;++i) {
-    	req->setAttributes(the_attributes[i], i);
+    	req.setAttributes(the_attributes[i], i);
     }
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
 }
 
 }} // namespace certi/rtia
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/RTIA/RTIA.cc origin/RTIA/RTIA.cc
--- patched/RTIA/RTIA.cc	2012-01-19 14:36:23.000000000 +0400
+++ origin/RTIA/RTIA.cc	2011-07-11 15:17:24.000000000 +0400
@@ -32,32 +32,15 @@
 
 static PrettyDebug D("RTIA", "(RTIA) ");
 
-#ifdef RTIA_USE_THREAD
-void RTIA::launchRTIAthread( LibRTIABufSet *bufSet ) {
-	init( bufSet );
-	try { m_thread = boost::thread( boost::bind(&RTIA::execute, this) ); }
-	catch ( boost::thread_resource_error &e ) {
-		std::cout << "cannot create RTIA thread: " << e.what() << std::endl;
-	}
-}
-#else // RTIA_USE_THREAD
 RTIA::RTIA(int RTIA_port, int RTIA_fd) {
-	init( RTIA_port, RTIA_fd );
-}
-#endif // RTIA_USE_THREAD
 
-#ifdef RTIA_USE_THREAD
-void RTIA::init( LibRTIABufSet *bufSet ) {
-	comm   = new Communications(bufSet);
-#else // RTIA_USE_THREAD
-void RTIA::init( int RTIA_port, int RTIA_fd ) {
-	comm   = new Communications(RTIA_port, RTIA_fd);
-#endif // RTIA_USE_THREAD
     clock = libhla::clock::Clock::getBestClock();
 
     // No SocketServer is passed to the RootObject (RTIA use case)
 	// socket server are passed to RootObject iff we are in RTIG.
     rootObject = new RootObject(NULL);
+
+    comm   = new Communications(RTIA_port, RTIA_fd);
     queues = new Queues ;
     fm     = new FederationManagement(comm,&stat);
     om     = new ObjectManagement(comm, fm, rootObject);
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/RTIA/RTIA.hh origin/RTIA/RTIA.hh
--- patched/RTIA/RTIA.hh	2012-01-19 14:35:41.000000000 +0400
+++ origin/RTIA/RTIA.hh	2010-03-21 20:10:11.000000000 +0300
@@ -25,7 +25,6 @@
 #define _CERTI_RTIA_HH
 
 // Project
-#include "config.h"
 #include "Communications.hh"
 #include "TimeManagement.hh"
 #include "FederationManagement.hh"
@@ -36,12 +35,8 @@
 #include "Statistics.hh"
 #include "Clock.hh"
 
-#ifdef RTIA_USE_THREAD
-#include <boost/thread.hpp>
-#endif
-
 namespace certi {
-	
+
 namespace rtia {
 
 /**
@@ -57,17 +52,12 @@
 class RTIA
 {
 public:
-#ifdef RTIA_USE_THREAD
-	RTIA() {}
-	void launchRTIAthread( LibRTIABufSet* bufSet );
-#else // RTIA_USE_THREAD
 	/**
 	 * RTIA constructor.
 	 * @param[in] RTIA_port the TCP port used
 	 * @param[in] RTIA_fd the file descriptor
 	 */
     RTIA(int RTIA_port, int RTIA_fd);
-#endif // RTIA_USE_THREAD
 
     /**
      * RTIA destructor.
@@ -83,13 +73,6 @@
     void displayStatistics();
 
 private:
-#ifdef RTIA_USE_THREAD
-	void init( LibRTIABufSet *bufSet );
-	boost::thread m_thread;
-#else // RTIA_USE_THREAD
-	void init( int RTIA_port, int RTIA_fd );
-#endif // RTIA_USE_THREAD
-
     RootObject *rootObject ;
 
     FederationManagement *fm ;
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/RTIA/RTIA_federate.cc origin/RTIA/RTIA_federate.cc
--- patched/RTIA/RTIA_federate.cc	2012-01-16 13:33:01.000000000 +0400
+++ origin/RTIA/RTIA_federate.cc	2011-09-03 01:42:24.000000000 +0400
@@ -1346,16 +1346,16 @@
 			// else goto TICK_RETURN
 
 		case TimeManagement::TICK_RETURN: {
-			DEFINE_REQ( M_Tick_Request );
+			M_Tick_Request msg_ack;
 			/* send TICK_REQUEST response
 			 */
 			if ( exc != e_RTIinternalError )
-				req->setException(exc);
+				msg_ack.setException(exc);
 			// terminate __tick() call in the federate
-			req->setMultiple(tm->_tick_result);
-			req->setMinTickTime(0); // unused
-			req->setMaxTickTime(0); // unused
-			comm->requestFederateService(req);
+			msg_ack.setMultiple(tm->_tick_result);
+			msg_ack.setMinTickTime(0); // unused
+			msg_ack.setMaxTickTime(0); // unused
+			comm->requestFederateService(&msg_ack);
 
 			tm->_tick_state = TimeManagement::NO_TICK;
 		}
@@ -1403,20 +1403,20 @@
 {
 	/* use virtual constructor in order to build  *
 	 * appropriate answer message.                */
-	Message *rep = M_Factory::create(req->getMessageType());
+	std::auto_ptr<Message> rep(M_Factory::create(req->getMessageType()));
 
 	G.Out(pdGendoc,"enter RTIA::processFederateRequest");
 
 	try {
 		switch(fm->_connection_state) {
 		case FederationManagement::CONNECTION_PRELUDE:
-			initFederateProcessing(req, rep);
+			initFederateProcessing(req, rep.get());
 			break;
 
 		case FederationManagement::CONNECTION_READY:
 		{
 			TypeException exc ;
-			chooseFederateProcessing(req, rep, exc);
+			chooseFederateProcessing(req, rep.get(), exc);
 			if ( exc != e_RTIinternalError && exc != e_NO_EXCEPTION) {
 				rep->setException(exc);
 			}
@@ -1771,7 +1771,7 @@
 		rep->getMessageType() != Message::TICK_REQUEST_STOP) {
 		// generic federate service acknowledgment
 		// the TICK_REQUEST confirmation is generated in processOngoingTick()
-		comm->sendUN(rep);
+		comm->sendUN(rep.get());
 		D.Out(pdDebug, "Reply send to Unix socket.");
 	}
 	G.Out(pdGendoc,"exit  RTIA::processFederateRequest");
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/RTIA/TimeManagement.cc origin/RTIA/TimeManagement.cc
--- patched/RTIA/TimeManagement.cc	2012-01-19 11:23:16.000000000 +0400
+++ origin/RTIA/TimeManagement.cc	2011-01-11 15:29:40.000000000 +0300
@@ -777,19 +777,21 @@
 // ----------------------------------------------------------------------------
 void
 TimeManagement::timeRegulationEnabled(FederationTime theTime, TypeException &e) {
-	D.Out(pdDebug,"Sending TIME_REGULATION_ENABLED to Federate");
-	DEFINE_REQ( M_Time_Regulation_Enabled );
-    req->setDate(theTime);
-    comm->requestFederateService(req);
+    M_Time_Regulation_Enabled req;
+
+    D.Out(pdDebug,"Sending TIME_REGULATION_ENABLED to Federate");
+    req.setDate(theTime);
+    comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
 void
 TimeManagement::timeConstrainedEnabled(FederationTime theTime, TypeException &e) {
-	D.Out(pdDebug,"Sending TIME_CONSTRAINED_ENABLED to Federate");
-	DEFINE_REQ( M_Time_Constrained_Enabled );
-    req->setDate(theTime);
-    comm->requestFederateService(req);
+    M_Time_Constrained_Enabled req;
+
+    D.Out(pdDebug,"Sending TIME_CONSTRAINED_ENABLED to Federate");
+    req.setDate(theTime);
+    comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -946,19 +948,19 @@
 TimeManagement::timeAdvanceGrant(FederationTime logical_time,
                                  TypeException &e)
 {
-    DEFINE_REQ( M_Time_Advance_Grant );
+    M_Time_Advance_Grant req;
 
-    req->setDate(logical_time);
+    req.setDate(logical_time);
 
     D.Out(pdRegister, "timeAdvanceGrant sent to federate (time = %f).",
-          req->getDate().getTime());
+          req.getDate().getTime());
 
     if (_lookahead_courant == epsilon2)
         _lookahead_courant = 0.0 ;
 
     _tick_state = TICK_NEXT;  // indicate the callback was processed
 
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
 
     _heure_courante = logical_time ;
     /* reset the sending of NULL PRIME message whenever we get TAG */
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/config.h.cmake origin/config.h.cmake
--- patched/config.h.cmake	2012-01-16 10:23:35.000000000 +0400
+++ origin/config.h.cmake	2011-01-09 21:01:44.000000000 +0300
@@ -115,12 +115,4 @@
 /* Define to 1 if the processor have WIN support */
 #cmakedefine HAVE_WIN_CLOCK 1
 
-/* Defines the architecture of RTIA in terms of processes and threads */
-#cmakedefine RTIA_USE_THREAD
 
-/* Macro required to avoid the heap use in multi-process mode */
-#ifndef RTIA_USE_THREAD
-#define DEFINE_REQ( MsgClass ) MsgClass local_req, *req = &local_req
-#else /* RTIA_USE_THREAD */
-#define DEFINE_REQ( MsgClass ) MsgClass *req = new MsgClass
-#endif /* RTIA_USE_THREAD */
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/libRTI/RTI1516ambPrivateRefs.cpp origin/libRTI/RTI1516ambPrivateRefs.cpp
--- patched/libRTI/RTI1516ambPrivateRefs.cpp	2012-01-19 14:46:51.000000000 +0400
+++ origin/libRTI/RTI1516ambPrivateRefs.cpp	2011-07-13 19:43:16.000000000 +0400
@@ -139,28 +139,22 @@
 
 } // End anonymous namespace
 
-#ifdef RTIA_USE_THREAD
-RTI1516ambPrivateRefs::RTI1516ambPrivateRefs( LibRTIABufSet *_bufSet ) {
-	bufSet = _bufSet;
-#else 
-RTI1516ambPrivateRefs::RTI1516ambPrivateRefs() {
+RTI1516ambPrivateRefs::RTI1516ambPrivateRefs()
+{
+	fed_amb      = NULL;
 #ifdef _WIN32
 	handle_RTIA  = (HANDLE)-1;
 #else
 	pid_RTIA     = (pid_t)-1;
 #endif
-	socketUn     = NULL;
-#endif
-	fed_amb      = NULL;
 	is_reentrant = false;
 	_theRootObj  = NULL;
+	socketUn     = NULL;
 }
 
 RTI1516ambPrivateRefs::~RTI1516ambPrivateRefs()
 {
-#ifndef RTIA_USE_THREAD
 	delete socketUn ;
-#endif
 }
 
 // ----------------------------------------------------------------------------
@@ -173,17 +167,13 @@
 }
 
 // ----------------------------------------------------------------------------
-Message* RTI1516ambPrivateRefs::executeService( Message *req, Message *rep )
+void
+RTI1516ambPrivateRefs::executeService(Message *req, Message *rep)
 {
-	G.Out(pdGendoc,"enter RTI1516ambPrivateRefs::executeService(%s)",req->getMessageName() );
+	G.Out(pdGendoc,"enter RTI1516ambPrivateRefs::executeService(%s,%s)",req->getMessageName(),rep->getMessageName());
 
 	D.Out(pdDebug, "sending request to RTIA.");
 
-	Message::Type req_type = req->getMessageType();
-#ifdef RTIA_USE_THREAD
-	bufSet->fed2amb.push( req );
-	// Cannot use req any more
-#else // RTIA_USE_THREAD
 	try {
 		req->send(socketUn,msgBufSend);
 	}
@@ -192,19 +182,16 @@
 		if ( req->getMessageType() == certi::Message::CLOSE_CONNEXION)
 		{
 			std::cerr << "libRTI: Could not execute 'Close connexion' service (Network error). Service request ignored." << std::endl;
-			return NULL;
+			return;
 		} else
 		{
 			throw rti1516::RTIinternalError(L"libRTI: Network Write Error");
 		}
 	}
-#endif // RTIA_USE_THREAD
-	
+
 	D.Out(pdDebug, "waiting RTIA reply.");
 
-#ifdef RTIA_USE_THREAD
-	rep = bufSet->amb2fed.pull();
-#else // RTIA_USE_THREAD
+	// waiting RTI reply.
 	try {
 		rep->receive(socketUn,msgBufReceive);
 	}
@@ -212,12 +199,11 @@
 		std::cerr << "libRTI: exception: NetworkError (read)" << std::endl ;
 		throw rti1516::RTIinternalError(L"libRTI: Network Read Error waiting RTI reply");
 	}
-#endif // RTIA_USE_THREAD
 
 	D.Out(pdDebug, "RTIA reply received.");
 
 
-	if (rep->getMessageType() != req_type) {
+	if (rep->getMessageType() != req->getMessageType()) {
 		std::cout << "LibRTI: Assertion failed: rep->type != req->type" << std::endl ;
 		throw rti1516::RTIinternalError(L"RTI1516ambPrivateRefs::executeService: "
 				L"rep->type != req->type");
@@ -230,8 +216,6 @@
 
 	D.Out(pdDebug, "exception processed.");
 	G.Out(pdGendoc,"exit RTI1516ambPrivateRefs::executeService");
-	
-	return rep;
 }
 
 void
@@ -239,10 +223,8 @@
 {
 	G.Out(pdGendoc,"enter RTI1516ambPrivateRefs::sendTickRequestStop");
 
-#ifdef RTIA_USE_THREAD
-	bufSet->fed2amb.push( new M_Tick_Request_Stop );
-#else // RTIA_USE_THREAD
-	M_Tick_Request_Stop req;
+	M_Tick_Request_Stop req, rep ;
+
 	try {
 		req.send(socketUn, msgBufSend);
 	}
@@ -250,12 +232,7 @@
 		std::cerr << "libRTI: exception: NetworkError (write)" << std::endl ;
 		throw rti1516::RTIinternalError(L"libRTI: Network Write Error");
 	}
-#endif // RTIA_USE_THREAD
 
-#ifdef RTIA_USE_THREAD
-	delete bufSet->amb2fed.pull();
-#else // RTIA_USE_THREAD
-	M_Tick_Request_Stop rep;
 	try {
 		rep.receive(socketUn, msgBufReceive);
 	}
@@ -263,7 +240,6 @@
 		std::cerr << "libRTI: exception: NetworkError (read)" << std::endl ;
 		throw rti1516::RTIinternalError(L"libRTI: Network Read Error waiting RTI reply");
 	}
-#endif // RTIA_USE_THREAD
 
 	// ignore the response, ignore exceptions
 	// rep->type == Message::TICK_REQUEST;
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/libRTI/RTI1516ambPrivateRefs.h origin/libRTI/RTI1516ambPrivateRefs.h
--- patched/libRTI/RTI1516ambPrivateRefs.h	2012-01-19 14:45:03.000000000 +0400
+++ origin/libRTI/RTI1516ambPrivateRefs.h	2010-04-28 22:48:30.000000000 +0400
@@ -22,47 +22,31 @@
 // $Id: RTI1516ambPrivateRefs.h,v 1.1 2010/04/28 18:48:30 erk Exp $
 // ----------------------------------------------------------------------------
 
-#include "config.h"
 #include <RTI/certiRTI1516.h>
 //#include "fedtime.hh"
 #include "Message.hh"
 #include "RootObject.hh"
 #include "MessageBuffer.hh"
 
-#ifdef RTIA_USE_THREAD
-#include "../libRTIA/librtia_buf.hpp"
-#endif
-
 using namespace certi ;
 
 class RTI1516ambPrivateRefs
 {
 public:
-	~RTI1516ambPrivateRefs();
-#ifdef RTIA_USE_THREAD
-	RTI1516ambPrivateRefs( LibRTIABufSet *bufSet );
-	LibRTIABufSet *bufSet;
-#else
 	RTI1516ambPrivateRefs();
-#endif
+    ~RTI1516ambPrivateRefs();
 
-    void processException( Message* msg );
-    Message* executeService( Message *request, Message *reply );
-	template< typename MSG >
-	MSG* executeServiceTmpl( MSG* request, MSG* reply ) {
-		return (MSG*)executeService(request, reply);
-	}
+    void processException(Message *);
+    void executeService(Message *requete, Message *reponse);
     void sendTickRequestStop();
     void callFederateAmbassador(Message *msg) throw (rti1516::RTIinternalError);
     void leave(const char *msg) throw (rti1516::RTIinternalError);
 
-#ifndef RTIA_USE_THREAD
 #ifdef _WIN32
 	  HANDLE	handle_RTIA;
 #else
     pid_t pid_RTIA ; //!< pid associated with rtia fork (private).
 #endif
-#endif // RTIA_USE_THREAD
 
     //! Federate Ambassador reference for module calls.
     rti1516::FederateAmbassador *fed_amb ;
@@ -72,10 +56,8 @@
 
     RootObject *_theRootObj ;
 
-#ifndef RTIA_USE_THREAD
     SocketUN *socketUn ;
     MessageBuffer msgBufSend,msgBufReceive ;
-#endif
 };
 
 // $Id: RTI1516ambPrivateRefs.h,v 1.1 2010/04/28 18:48:30 erk Exp $
